//
// "$Id: $"
//
//
//                   Copyright (c) 2003, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//

#include "CueEdit.h"
#include "Gui.h"
#include <FL/Fl_File_Chooser.H>

#ifdef WIN32
#define snprintf _snprintf
#endif

extern Gui *gui;


ClockEdit::ClockEdit(int X, int Y, int W, int H, const char *T) :
	Fl_Group(X, Y, W, H, T)
{


	need_reload = 0;
	clock_pool = NULL;
	ma_pool = 0;
	nb_pool = 0;

	last_10ms = 0;

	res = new Fl_Box( X + W - 2, Y + H - 2, 2, 2);
	res->hide();
	resizable(res);

	hide();
	end();
}


void ClockEdit::it_s_time_to_do_it(int time_10ms)
{

/*
	last_10ms = time_10ms;

	if (play) {
		char buf[256];
		step = (int)((time_10ms - start_10ms) * (data->bpm / 6000.0));	
		
		if (step >= data->time_length) {
			//int n;
			if (!cue_loop->value()) {
				cue_play->value(0);
				play = 0;
				Fl::awake();
				
				return;
			}
			//n = (int)(data->time_length / (data->bpm / 6000.0));
			//if (n < 1) n = 1;
			//start_10ms += n; 
			//step = (int)((time_10ms - start_10ms) * (data->bpm / 6000.0));
		}
		if (step < 0) step = 0;
		snprintf(buf, 256, "%05d.%02d", step / 100, step % 100);
		cue_step->value(buf);
		Fl::awake();
		if (need_sync_output) need_sync_output = 0;
		data->do_step(step);
	} else 	if (need_sync_output) {
		need_sync_output = 0;
		data->do_step(step);
		Fl::awake();
	}
*/	

}



Clock *ClockEdit::get(const char *seq)
{
	int i, f;
	f = -1;
	for (i = 0; i < nb_pool; i++) {
		if (clock_pool[i]) {
			//if (need_reload) clock_pool[i]->load(seq);
			need_reload = 0;
			return clock_pool[i];
		} else {
			f = i;
		}
	}

	if (f == -1) {
		f = nb_pool++;
		if (f >= ma_pool) {
			int i;
			ma_pool += 32;
			clock_pool = (Clock**) realloc(clock_pool,
				sizeof(Clock*) * (ma_pool));
			for (i = f; i < ma_pool; i++) {
				clock_pool[i] = NULL;
			}
		}
	}

	clock_pool[f] = new Clock();
	//clock_pool[f]->load(seq);
	return clock_pool[f];
}

//
// End of "$Id: $".
//

