//
// "$Id: $"
//
//
//                   Copyright (c) 2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//

#ifndef Devices_H
#define Devices_H

#include <FL/Fl_Group.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Slider.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Table.H>
#include <FL/Fl_Int_Input.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Menu_Button.H>

#ifdef WIN32
#include <winsock.h>
#else
#include <sys/time.h>
#endif

#include <stdlib.h>
#include "DevicesTable.h"
#include "Fixture.h"

class Devices : public Fl_Group {
public:
	char changed;

	int stage1;
	int stage2;
	int stage_max_fix;
	int stage_fix;

	Fl_Input *map_file_inp;
	Fl_Button *map_sel_but;
	Fl_Button *map_save_but;
	Fl_Button *map_new_but;

	Fl_Box *res;

	DevicesTable *table;
	
	Fixture **fix;
	int nb_fix;
	int mal_fix;

	Devices(int X, int Y, int W, int H, const char *t);
	~Devices();

	void set_value(int r, int c, const char *v);
	const char *get_value(int r, int c);
	
	void clear_map();
	void load_map();
	void save_map();
	void new_map();
	void open_map();

	void grow();

	void load_word(const char *word, int len, int depth, int closed);
};


#endif // Devices_H

//
// End of "$Id: $".
//

