//
// "$Id: $"
//
//
//                   Copyright (c) 2003, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//

#include "Gui.h"
extern Gui *gui;

static Fl_Menu_Item main_menu[] = {
	{"File"},
	{"Help"},
	0
};

CRITICAL_SECTION Gui::cs;

Gui::Gui(int X, int Y, int W, int H) : Fl_Tabs (X, Y, W, H) 
{
	int i;
	Fl_Group *g;

	gui = this;

	InitializeCriticalSection(&cs);

	work_dir = "d:/temp/dmx";
	fixture_dir = "d:/temp/dmx/fixture";


	tab_height(19);

	//g = new Fl_Group(X + 5, Y + 21, W - 10, H - 25, "Console");
	//g->end();

	clock_edit = new ClockEdit(X + 5, Y + 21, W - 10, H - 25, "Console");

	//list_edit = new ListEdit(X + 3, Y + 21, W - 6, H - 24, "Cue list");
	cue_edit = new CueEdit(X + 3, Y + 21, W - 6, H - 24, "Cues");
	sequence = new Sequence(X + 3, Y + 21, W - 6, H - 24, "Sequences");
	//g = new Fl_Group(X + 5, Y + 21, W - 10, H - 25, "Panel");
	//g->end();	
	devices = new Devices(X + 3, Y + 21, W - 6, H - 24, "Devices");	
	universes = new Universes(X + 3, Y + 21, W - 6, H - 24, "Universes");
	
	sequence->fix_tree->root((void*)-1);

	resizable(universes);
	end();
	for (i = 0; i < 32; i++) {
		in_universes[i] = new Universe(W - 10, H - 25, i, 0); // input
		out_universes[i] = new Universe(W - 10, H - 25, i, 1); // output / id = 0
	}
	
	parent()->begin();
	menu_bar = new Fl_Menu_Bar(0, 0, 620, 23);
	menu_bar->menu(main_menu);
  	status = new Fl_Output(0, 430, 620, 20);
	status->value("DMX Step 0.1.0 by O'ksi'D Software...");

	jump = 0;

	printf( "main %d\n", GetCurrentThreadId() );
	
}

void Gui::unlock() {
/*
	static int pi;
	 if(GetCurrentThreadId() != pi) {
		 printf( "unlock %d\n", GetCurrentThreadId() );
		pi = GetCurrentThreadId();
	}
*/
#ifdef WIN32
	LeaveCriticalSection(&cs);
#endif

}


void Gui::lock() {
/*	static int pi;
	 if(GetCurrentThreadId() != pi) {
		 printf( "lock %d\n", GetCurrentThreadId() );
		pi = GetCurrentThreadId();
	}
*/
#ifdef WIN32
	EnterCriticalSection(&cs);
#endif
}

void Gui::suspend()
{
}

void Gui::resume()
{
}



//
// End of "$Id: $".
//

