//
// "$Id: $"
//
//
//                   Copyright (c) 2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//

#ifndef ListEdit_H
#define ListEdit_H

#include <FL/Fl_Group.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Slider.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Table.H>
#include <FL/Fl_Int_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Float_Input.H>
#include "List.h"
#include "ListTable.h"

class ListEdit : public Fl_Group {
public:
	char changed;

	int need_sync_output;
	int last_10ms;
	int start_10ms;

	int play;

	static Fl_Menu_Item action_item[];

	Fl_Input *list_file_inp;
	Fl_Button *list_sel_but;
	Fl_Button *list_save_but;
	Fl_Button *list_saveas_but;
	Fl_Button *list_new_but;

	Fl_Float_Input *list_step;
	Fl_Button *list_step_plus;
	Fl_Button *list_step_minus;
	Fl_Output *list_length;
	Fl_Float_Input *list_bpm;

	Fl_Button *list_live;
	Fl_Button *list_loop;
	Fl_Button *list_begin;
	Fl_Button *list_end;
	Fl_Button *list_play;
	Fl_Button *list_stop;
	
	//Fl_Button *list_export;

	ListTable *list_table;
	Fl_Box *res;

	int step;
	List *data;

	int need_reload;
	int ma_pool;
	int nb_pool;
	List **list_pool;	

	
	ListEdit(int X, int Y, int W, int H, const char *t);

	int handle(int e);

	void save_list(const char *file = NULL);
	void new_list();
	void open_list(const char *file = NULL);

	void it_s_time_to_do_it(int time_10ms);
	char *get_value(int R, int C);
	void set_value(int row_edit, int col_edit);

	List *get(const char *cu);
};


#endif // ListEdit_H

//
// End of "$Id: $".
//

