//
// "$Id: $"
//
//
//                   Copyright (c) 2003, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//

#ifndef Sequence_H
#define Sequence_H

#include <FL/Fl_Group.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Slider.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Table.H>
#include <FL/Fl_Int_Input.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Float_Input.H>
#include "Step.h"
#include "FixtureTree.h"

class Sequence : public Fl_Group {
public:
	char changed;

	int need_sync_output;
	int last_10ms;
	int start_10ms;

	int play;

	FixtureTypeChannelGroup *grp;

	Fl_Input *seq_file_inp;
	Fl_Button *seq_sel_but;
	Fl_Button *seq_save_but;
	Fl_Button *seq_saveas_but;
	Fl_Button *seq_new_but;

	Fl_Float_Input *seq_step;
	Fl_Int_Input *seq_length;
	Fl_Button *seq_step_plus;
	Fl_Button *seq_step_minus;

	Fl_Button *seq_low_res;
	Fl_Float_Input *seq_bpm;
	Fl_Button *seq_live;
	Fl_Button *seq_loop;
	Fl_Button *seq_begin;
	Fl_Button *seq_end;
	Fl_Button *seq_play;
	Fl_Button *seq_stop;
	
	Fl_Button *seq_edit;

	FixtureTree *fix_tree;

	Fl_Scroll *slider_scroll;

	Fl_Box *res;

	int step;
	StepGroup *data;

	int need_reload;
	int ma_pool;
	int nb_pool;
	StepGroup **sequence_pool;	

	Sequence(int X, int Y, int W, int H, const char *t);
	~Sequence();

	int handle(int e);

	void save_seq();
	void saveas_seq();
	void new_seq();
	void open_seq();

	void it_s_time_to_do_it(int time_10ms);

	void fix_tree_cb(void);

	StepGroup *get(const char *seq);
};


#endif // Sequence_H

//
// End of "$Id: $".
//

