//
// "$Id: $"
//
//
//                   Copyright (c) 2003-2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//

#ifndef Step_H
#define Step_H

#include "Devices.h"
#include <stdio.h>

struct ActionStr {
public:
	int time;
	int device;
	int channel;
	int curve;
	int mix_mode;
	int value;
	int next_time;
	int next_value;
};

typedef struct ActionStr Action;

class Step {
public:
	int time;

	int ma_action;
	int nb_action;
	Action *action;

	Step(int t);
	~Step();
	
	void add_action(int de, int ch, int cu, int mi, int va, int nt, int nv);
	void del_action(int de, int ch);
};

struct StepDevMap {
	char *name;
	int org_id;
	int cur_id;
};

class StepGroup {
public:
	char changed;

	char *file_name;

	int time_length;
	int bpm;
	int live;
	double divisor;

	int stage1;
	int stage2;
	int stage3;
	int stage_time;
	int stage_device;
	int stage_value;
	int stage_curve;
	int stage_mix_mode;
	int stage_channel;
	int stage_last_level;

	int ma_step;
	int nb_step;
	Step **step;

	int ma_stack;
	int nb_stack;
	Action *stack;

	int nb_dev;
	int *dev;

	int current;

	StepGroup();
	~StepGroup();

	void update_stack(Step *st);

	void add_action(int t, int de, int ch, int cu, int mi, int va);
	void del_action(int t, int de, int ch);

	void do_step(int t);

	int load(const char *file);
	int save(const char *file = NULL);
	void load_word(const char *word, int len, int depth, int closed);
};

#endif // Step_H

//
// End of "$Id: $".
//

