//
// "$Id: $"
//
//
//                   Copyright (c) 2003-2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//

#ifndef sexpr_H
#define sexpr_H

#include <stdio.h>

struct sexpr_struct {	
	char *text;
	int text_len;
	int depth;
	int closed;
	int *elem;

	FILE *fd;
	int mlen;
	int melem;	
	char *buf;	
	char *ptr1;
	char *ptr2;
	char *end;
	int state;
	int read_len;
};

typedef struct sexpr_struct SEXPR;

#define sexpr_element_id(S, D) ((S) ? (((D) > 0 && (D) <= (S)->depth) ? (S)->elem[D] : (S)->elem[(S)->depth]) : (0))
#define sexpr_closed(S) ((S) ? ((S)->closed) : (0))
#define sexpr_depth(S) ((S) ? ((S)->depth) : (0))
#define sexpr_text(S) ((S) ? ((S)->text) : (""))
#define sexpr_text_length(S) ((S) ? ((S)->text_len) : (0))
#define sexpr_close(S) (sexpr_delete(&(S)))

int sexpr_quote(const char *in, int in_len, char *buffer, int buffer_len);
int sexpr_unquote(const char *in, int in_len, char *buffer, int buffer_len);

SEXPR *sexpr_open(const char *file_name);
int sexpr_read(SEXPR *s);
int sexpr_delete(SEXPR **s);

#endif // sexpr_H

//
// End of "$Id: $".
//

